=== debian/changelog ===
libreoffice (1:3.6.2~rc2-0ubuntu6) raring; urgency=low

  * cherry pick from upstream 3.6 branch Change-Id
    I2e02156ffc30629476b80134ffb0b50e793f7ead (LP: #585910)
    - improve rendering of the "faux bold" font on Impress
      presentation

 -- Nobuto MURATA <nobuto@ubuntu.com>  Mon, 26 Nov 2012 13:27:22 +0100

libreoffice (1:3.6.2~rc2-0ubuntu5) raring; urgency=low

  * debian/rules: Fix quoting.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 26 Oct 2012 15:22:27 +0200

libreoffice (1:3.6.2~rc2-0ubuntu3) quantal-proposed; urgency=high

  * packaging shouldnt try to move stuff it doesnt build on armel/armhf

 -- Bjoern Michaelsen <bjoern.michaelsen@canonical.com>  Mon, 08 Oct 2012 13:19:24 +0200

libreoffice (1:3.6.2~rc2-0ubuntu2) quantal-proposed; urgency=high

  * do not build extensions on armel, armhf for bug 1062448 
  * update to unitymenus patch Change-Id
    Ia8f82024e56ad83c8979d60df3c94e8209fe2552 (LP: #1062757) (LP: #1062812)

 -- Bjoern Michaelsen <bjoern.michaelsen@canonical.com>  Sun, 07 Oct 2012 10:18:24 +0200

libreoffice (1:3.6.2~rc2-0ubuntu1) quantal-proposed; urgency=low

  * update to unitymenus patch to 7ffc24eb76325afef89c25e8a7fe13124ed5a041 
  * lo-menubar is obsolete with this (C/P/R needs to stay there until 14.04 LTS)

 -- Bjoern Michaelsen <bjoern.michaelsen@canonical.com>  Fri, 05 Oct 2012 15:54:49 +0200

libreoffice (1:3.6.2~rc2-0ubuntu1~ppa2) quantal; urgency=low

  * update to Antonios fixes for today

 -- Bjoern Michaelsen <bjoern.michaelsen@canonical.com>  Thu, 04 Oct 2012 21:26:52 +0200

libreoffice (1:3.6.2~rc2-0ubuntu1~ppa1) quantal; urgency=low

  * ttf-sil-gentium-basic has been renamed to fonts-sil-gentium 
  * new upstream release 3.6.2.2
  * update unitymenus patch to 767bae2cefd4cfcaa852c2c39e651bab81e4e134

 -- Bjoern Michaelsen <bjoern.michaelsen@canonical.com>  Wed, 03 Oct 2012 14:52:05 +0200

libreoffice (1:3.6.1~rc2-1ubuntu6~ppa1) quantal; urgency=low

  * update unitymenus to commit 22774aff3f1d4b2a09d713555e0180a3eded3155
  * make metapackage explicit in short description (LP: #1045165)
  * drop ttf-sil-gentium-basic and filter-mobiledev to suggests on
    metapackage (LP: #1045165)

 -- Bjoern Michaelsen <bjoern.michaelsen@canonical.com>  Fri, 21 Sep 2012 16:55:33 +0200

libreoffice (1:3.6.1~rc2-1ubuntu5) quantal; urgency=low

  * update unitymenus to commit a12a4a6befd8688495b966fb4741f61242740389
  * Menus should now correctly show/hide when (not) needed (LP: #1044657)

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 14 Sep 2012 14:55:49 -0600

libreoffice (1:3.6.1~rc2-1ubuntu4) quantal; urgency=low

  * No-change rebuild for libpoppler27 -> libpoppler28 transition.

 -- Robert Ancell <robert.ancell@canonical.com>  Thu, 13 Sep 2012 12:05:57 +1200

libreoffice (1:3.6.1~rc2-1ubuntu3) quantal-proposed; urgency=low

  * Fix i386 FTBFS with s/VX/XV/ and adding a missing cat in debian/rules.

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 02 Sep 2012 03:35:24 -0600

libreoffice (1:3.6.1~rc2-1ubuntu2) quantal-proposed; urgency=low

  * test for ca-XV files before trying to use them
    - ca-XV l10n files are special-cased in that they are merged in the ca l10n
      packaged
    - the libreoffice-l10n-* files are generated by gid2pkgdirs.sh
    - for an binary-only, arch dep-only build ca-XV might be set in
      LANGPACKISOS and HELPISOS, even though we do not pass such parameters to
      ./autogen.sh and thus neither scp2 nor gid2pkgdirs.sh generate any l10n 
      package files
    - this wasnt discovered on the ppa builds because of ppa filesystem
      limitations, we can only building with a subset of l10n (not ca-XV) there, 
      thus shadowing the issue, even though we do binary-only, arch dep-only builds.

 -- Bjoern Michaelsen <bjoern.michaelsen@canonical.com>  Sat, 01 Sep 2012 02:19:11 +0200

libreoffice (1:3.6.1~rc2-1ubuntu1) quantal-proposed; urgency=low

  * version bump for quantal main including upstream, debian and unitymenu
    fixes
  * update unitymenus to commit 91f332524f3b632b3e96d69921e2593c161f0ea5

 -- Bjoern Michaelsen <bjoern.michaelsen@canonical.com>  Fri, 31 Aug 2012 17:12:06 +0200

libreoffice (1:3.6.1~rc2-1ubuntu1~ppa1) quantal; urgency=low

  * merge from debian 3.6.1~rc2-1
  * waiting for clucene FFE (lp#1042192) 
  * make libreoffice-draw recommend libreoffice-pdfimport (LP: #966498)
  * update unitymenus to commit e9db2efab56f37b59fc10da18af73d9cf09846d8

 -- Bjoern Michaelsen <bjoern.michaelsen@canonical.com>  Tue, 28 Aug 2012 01:38:17 +0200

libreoffice (1:3.6.1~rc2-1) experimental; urgency=low

  * new upstream release candidate

  * debian/patches/debian-debug.diff: patch new gb_SYMBOLS in unxgcc.mk to
    make ENABLE_SYMBOLS=SMALL (-g1) working again..
  * debian/patches/debian/patches/kfrebsd-add-missing-P_SEP.diff: fix Java build
    on kfreebsd (non-broken CLASSPATH)

  * src/2ab442d169156f34c379c968f3f482dd-zlib-1.2.7.tar.bz2: remove
    zlib-1.2.7/doc/rfc195{0,1,2}.txt (closes: #685133)

  * debian/rules:
    - save some space/build time: build only with en-US in build-arch first
      and build sdext/mysqlc (localized help/descriptions) manually with all
      languages after make check; remove buildd special-casing for
      languages
  * debian/control.fonts.in: remove ttf-opensymbol transitional package 
  * debian/control.in:
    - remove obsolete sharutils, po-debconf and wget | curl build-deps

 -- Rene Engelhard <rene@debian.org>  Thu, 23 Aug 2012 22:34:27 +0200

libreoffice (1:3.6.0~rc4-0ubuntu3) quantal-proposed; urgency=low

  * backport patch to evade fdo#51324 (LP: #1017125) 
  * pure white progress bar is better for now (LP: #1026059)
  * reenable subsequentcheck 
  * update patch queue:
    - readd split-binfilters-and-evo.diff from debian
    - add backported dont-let-autoextension-interfere-with-kfiledialog.diff  
      from debian
    - remove obsolete force C++ ABI patch
    - remove obsolete lp-904212-add-missing-mimetypes-to-impress.desktop.diff

